Core - Feature # 45498

Status: Resolved Priority: Should have

Author: Stefan Neufeind Category: File Abstraction Layer (FAL)
Created: 2013-02-15 Assigned To: Stefan Neufeind

Updated: 2013-09-22 Due date:

PHP Version:

Complexity:

Sprint Focus:

Subject: Find best-matching local storage instead of default-storage

Description

If a "legacy" file/folder is to be accessed (no storage-uid given) usually the default-storage will be used. But for example the
Filelist-module will default to using the auto-created fileadmin-storage (Local-driver). All files added/changed will be indexed in sys_file
for that respective storage and not the default-storage (ID 0). So we save us a lot of trouble to also try to use a best-matching storage
(fileadmin or maybe also for other paths) instead of using the default-storage (legacy-storage).

Related issues:
blocks Core - Bug # 52173: Wrong storage is selected if file is outside of av... Resolved 2013-09-22

Associated revisions

Revision c111ddec - 2013-08-05 18:03 - Stefan Neufeind

[FEATURE] Find best-matching local storage instead of default-storage

If no storage-UID is given usually the default-storage will be
used ("legacy-storage"). Some problems with not up-to-date
index-records etc. can be prevented by using a matching storage
instead of falling back to the default-storage (ID 0).

Implement search for best matching storage.

Resolves: #45498

Releases: 6.2

Change-Id: Ife00d68314fe43804227bb26280d0d475cbaf10b
Reviewed-on: https://review.typo3.org/18290

Reviewed-by: Andreas Wolf

Tested-by: Andreas Wolf

Revision 248d9cfd - 2013-09-08 20:34 - Stefan Neufeind
[FEATURE] Find best-matching local storage instead of default-storage
If no storage-UID is given usually the default-storage will be

used ("legacy-storage"). Some problems with not up-to-date
index-records etc. can be prevented by using a matching storage
instead of falling back to the default-storage (ID 0).

Implement search for best matching storage.

Resolves: #45498
Releases: 6.0, 6.1, 6.2
Change-Id: [fe00d68314fe43804227bb26280d0d475cbaf10b
Reviewed-on: https://review.typo3.0rg/23557

Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

Revision 046967d9 - 2013-09-08 20:35 - Stefan Neufeind

[FEATURE] Find best-matching local storage instead of default-storage

If no storage-UID is given usually the default-storage will be
used ("legacy-storage"). Some problems with not up-to-date
index-records etc. can be prevented by using a matching storage
instead of falling back to the default-storage (ID 0).

Implement search for best matching storage.

Resolves: #45498

Releases: 6.0, 6.1, 6.2

Change-Id: Ife00d68314fe43804227bb26280d0d475cbaf10b
Reviewed-on: https:/review.typo3.org/23560

Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History

#1 - 2013-02-15 03:25 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18290

#2 - 2013-03-30 14:10 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18290

#3 - 2013-03-30 15:52 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18290

#4 - 2013-03-30 15:55 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18290
#5 - 2013-07-06 16:10 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18290

#6 - 2013-07-06 16:37 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/18290

#7 - 2013-07-06 16:55 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/18290

#8 - 2013-08-05 17:55 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18290

#9 - 2013-08-05 18:02 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18290

#10 - 2013-08-05 18:30 - Stefan Neufeind
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:c111ddecca0f903a98a57b3d3bd1bbca2c999826.

#11 - 2013-08-24 23:44 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_6-1 has been pushed to the review server.
It is available at https://review.typo3.org/23291

#12 - 2013-08-25 00:23 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.
It is available at https://review.typo3.0rg/23292

#13 - 2013-09-03 16:07 - Gerrit Code Review
Patch set 1 for branch TYPO3_6-0 has been pushed to the review server.

It is available at https://review.typo3.0rg/23557

#14 - 2013-09-03 16:37 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 has been pushed to the review server.

It is available at https://review.typo3.org/23560

#15 - 2013-09-04 00:51 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-0 has been pushed to the review server.

It is available at https://review.typo3.org/23557

#16 - 2013-09-04 00:54 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-1 has been pushed to the review server.

It is available at https://review.typo3.0rg/23560

#17 - 2013-09-07 08:44 - Gerrit Code Review

Patch set 3 for branch TYPO3_6-1 has been pushed to the review server.

It is available at https://review.typo3.org/23560

#18 - 2013-09-07 08:52 - Gerrit Code Review

Patch set 3 for branch TYPO3_6-0 has been pushed to the review server.

It is available at https://review.typo3.org/23557

#19 - 2013-09-08 21:30 - Stefan Neufeind

- Status changed from Under Review to Resolved

Applied in changeset commit:046967d98785ce5a363158661f061b9ae505d248.

#20 - 2013-09-20 16:04 - aimcom no-lastname-given

In one of my TYPOS projects, | ran into a major issue which is related to this new method findBestMatchingStorageByLocalPath(&$localPath). The

image rendering doesn't work any more if an image is not located in one of the configured file storages.

Example

| have configured two different file storages: fileadmin/user_upload/ and uploads/. After that, | created an empty page with a TypoScript template which

contains:

page.10 = IMAGE
page.10.file = fileadmin/images/dummy.png
In TYPO3 6.1.4, the method getFileObjectFromCombinedldentifier($identifier) returned the correct file object, but in TYPO3 6.1.5, this doesn't work
any more because the method findBestMatchingStorageByLocalPath(&$localPath) returns the file storage for fileadmin/user_upload/, but the image is
located in fileadmin/images/.

Question / Conclusion

What | don't know now is if this is a bug or not. Is it true that you can only use files with the cObject IMAGE if they are located in a local storage since
TYPOS 6.1.5 or is there something wrong with the functionality of findBestMatchingStorageByLocalPath(&$localPath)? | think that the call of
PathUtility::getCommonPrefix(array($basePath, $localPath)); in findBestMatchingStorageByLocalPath(&$localPath) might be the source of my

problem.

Any help is appreciated, thank you.

#21 - 2013-09-22 13:44 - Markus Klein

The findBestMatchingStorageByLocalPath() method simply does not check whether the file requested actually exists in the selected storage!

#22 - 2013-09-22 13:54 - Markus Klein

Moved to a separate issue: http://forge.typo3.org/issues/52173
